package bran.spring.jacn;

import org.jdom.Attribute;
import org.jdom.Element;

/**
 * seems to me all XmlElementObject best describes rvalue. 
 * @author bran
 *
 */
class ConstObject extends XmlElementObject {
	String stringValue;
	ConstObject(Object cst) {
		super(cst);
		e = new Element("value");
		stringValue = cst.toString();
		// convert class internal name to  regular name
		// jdk1.5 load class descr on the stack for .class syntax
		if (stringValue.startsWith("L") && stringValue.endsWith(";")
				&& stringValue.indexOf("/") > 0) {
			stringValue = ConvertUtil.desc2reg(stringValue);
		}
		// a hack to allow my customized beanfactory to control the 
		// JSF binding. see SpringFacesBeanFactory
		//
		if (stringValue.trim().startsWith("#{") && stringValue.trim().endsWith("}")) {
			e.getAttributes().add(new Attribute("type", "java.lang.String"));
		}
		e.setText(stringValue);
	}
	public String toString() {
		return stringValue;
	}
}