package bran.spring.jacn;

import org.jdom.Attribute;
import org.jdom.Element;

public class ElementFactory {

	public static Element newRefPropElement(String name, String beanName) {
		// <property name="name" ref="beanName"
		Element p = newPropElement(name);
		addAttr(p, "ref", beanName);
		return p;
	}

	public static void addAttr(Element p, String attName, String attValue) {
		p.getAttributes().add(new Attribute(attName, attValue));
	}

	public  static Element newPropElement(String name) {
		Element element = new Element("property");
		addAttr(element, "name", name);
		return element;
		
	}

}
