/**
 * @author bran
 */
package bran.spring.jacn;

import org.jdom.Attribute;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.xpath.XPath;
import org.springframework.beans.factory.config.PropertyPlaceholderConfigurer;
/**
 * just some idea for now. not working yet
 * @author bran
 *
 */
public class JacnBase implements JacnPlugin{
	/**
	 * design time marker API. To bring a {@link PropertyPlaceholderConfigurer} to
	 * the current context. Default name is propertyPlaceholderConfigurer with lowercase
	 * first letter. 
	 * 
	 * @param propFile
	 */
	public static final String HOLDER_BEAN_NAME = "propertyPlaceholderConfigurer";
	public static final String HOLDER_BEAN_CLASS = PropertyPlaceholderConfigurer.class.getName();
	public static void loadProperties(String propFile) {}
	public static void loadPropertiesImpl(Element root, String propFile){
		assertRoot(root);
		/*    <bean id="propertyConfigurer" class="org.springframework.beans.factory.config.PropertyPlaceholderConfigurer">
        <property name="locations">
            <list>
                <value>classpath:mail.properties</value>
                <value>classpath:database.properties</value>
            </list>
        </property>
        </bean>
    */	
		Element phNode = getBeanNode(root, HOLDER_BEAN_NAME);
		if (phNode == null) {
			phNode = newPlaceHolderBeanNode();
			root.addContent(phNode);
		}
		
		Element elist = getElement(phNode, "//bean/property/list");
		elist.addContent(newValueElement("propFile"));
		
	}
	
	public static void markPrototype(Object fld) {}
	public static void markPrototypeImpl(Element root, String fldName){
		Element e = getBeanNode(root, fldName);
		e.getAttributes().add(new Attribute("singleton", "false"));
	}
	public static void makeTransactional(Object fld) {}
	public static void makeTransactional(Element root, String fldName){
		//todo impl this
	}

		
	protected static void assertRoot(Element root) {
		if (!root.getName().equals("beans"))
			notGood("<beans> root element expected");
	}
	
	protected static void notGood(String string) {
		throw new RuntimeException("BasicJacConfigurer: " + string); 
	}

	protected static Element newValueElement(String value) {
		Element e = new Element("value");
		e.setText(value);
		return e;
	}

	protected static Element newPlaceHolderBeanNode() {
		Element e = newBeanDef(HOLDER_BEAN_NAME, HOLDER_BEAN_CLASS);
		Element ep = newPropElement("locations");
		ep.addContent(newListNode());
		e.addContent(ep);
		return e;
	}

	private static Element newListNode() {
		return new Element("list");
	}
	
	protected static Element newPropElement(String propName) {
		Element r = new Element("property");
		r.getAttributes().add(new Attribute("name", propName));
		return r;
	}


	protected static Element newBeanDef(String id, String className) {
		Element e = new Element("bean");
		e.getAttributes().add(new Attribute("id", id));
		e.getAttributes().add(new Attribute("class", className));
		return e;
	}
	
	protected static Element getBeanNode(Element root, String beanName, String typeClass) {
		try {
			XPath xpath = XPath.newInstance("//beans/bean[@id='" + beanName + "' and @class='" + typeClass + "']");
			Object o = xpath.selectSingleNode(root);
			Element e = (Element) o;
			return e;
		} catch (JDOMException e) {
			e.printStackTrace();
			return null;
		}
	}
	
	protected static Element getBeanNode(Element root, String beanName) {
		String path = "//beans/bean[@id='" + beanName + "']";
		return getElement(root, path);
	}

	protected static Element getElement(Element root, String path) {
		try {
			XPath xpath = XPath.newInstance(path);
			Object o = xpath.selectSingleNode(root);
			Element e = (Element) o;
			return e;
		} catch (JDOMException e) {
			e.printStackTrace();
			return null;
		}
		
	}
	
	protected static Element newRefBean(String beanId) {
		Element e = new Element("ref");
		e.getAttributes().add(new Attribute("bean", beanId));
		return e;
	}

}
