package bran.spring.jacn;

import org.jdom.Element;
import org.springframework.aop.support.NameMatchMethodPointcutAdvisor;


public class NameMatchMethodPointcutAdvisorField extends FieldElementObj {

	/**
	 * 
	 * @param id the id of the advice name, not of this advisor!
	 * @param ao
	 */
	NameMatchMethodPointcutAdvisorField(String id, ArrayObject names) {
		super(
				NameMatchMethodPointcutAdvisor.class.getName(),
				id + "__NameMatchMethodPointcutAdvisor", 
				true);
		// the this.e is already defined based up here by the super ctor
		Element p = ElementFactory.newRefPropElement("advice", id);
		e.addContent(p);
		// set the mappedNamed property
		p = ElementFactory.newPropElement("mappedNames");
		p.addContent(((Element)names.e.clone()));
		e.addContent(p);
	}
}
