/*
 * $Log$
 * Revision 1.1  2006/07/02 04:59:46  branaway
 * added testcase for init and destroy, and other trivial
 *
 * Revision 1.1  2005/08/22 14:44:34  branaway
 * now local vars in the wire() method of jacnfig is always treated as inline beans (common collections exluded).
 *
 * Revision 1.1  2005/08/04 17:58:03  branaway
 * works with AppFuse now
 *
 */
package bran.jacn.test;

import bran.spring.jacn.AbstractJacnConfigFile;

/**
 * s + "gg" won't work
 * 
 * @author bran
 *
 */	
public class TestStringConcatenance extends JacnTestCase {

	/**
	 * load the config class
	 */
	
	protected Class[] getConfigClasses() {
		return new Class[] {Jacnfig.class};
	}

	public void testVarNaming() throws Exception {
		Foo foo2 = (Foo) getCtx().getBean("foo2");
		assertEquals("egg", foo2.getMsg() );
		
	}

	static class Foo {
		String msg;

		public String getMsg() {
			return msg;
		}

		public void setMsg(String msg) {
			this.msg = msg;
		}
	}
	
	static class Jacnfig extends AbstractJacnConfigFile {
		static Foo foo2;
			
		public void wire() throws Exception {
			foo2.setMsg("egg");  
//			String s = "e";
//			foo2.setMsg(s + "gg");  // this won't work. String concat becomes stringbuffer manipulation by SUN compiler
		}
	}
}
