package bran.jacn.testinternal;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;

import junit.framework.TestCase;

public class TestGetMeth extends TestCase {

	String msg;

	public void testGetMethWithChildType() throws SecurityException, NoSuchMethodException {
		Method m = Foe.class.getMethod("setList", new Class[] {List.class});
		assertNotNull(m);
	}

	public void testMethodChoice() {
		Foe f = new Foe();
		II i = new II();
		//f.setI(i);  // ambigous
	}

	interface I1 {}
	interface I2 {}
	
	static class II implements I1, I2 {}
	
	static class Foe {
		List list;
		
		I1 i1;
		I2 i2;
		
		public I1 getI1() {
			return i1;
		}

		public void setI(I1 i1) {
			this.i1 = i1;
		}

		public I2 getI2() {
			return i2;
		}

		public void setI(I2 i2) {
			this.i2 = i2;
		}

		public List getList() {
			return list;
		}

		public void setList(List list) {
			this.list = list;
		}
	}
}
