

import java.io.File;
import java.io.IOException;

import junit.framework.TestCase;

import org.jdom.JDOMException;

import bran.spring.jacn.AbstractJacnConfigFile;
import bran.spring.jacn.ConvertUtil;

public class QuickJacnSkeleton extends TestCase{

	public void testGenAppCon() throws JDOMException, IOException {
		File f = new File("D:\\eclipse-workspace\\confluence-1.4\\src\\applicationContext.xml");
		String ss = ConvertUtil.xml2JacnClass(f);
		System.out.println(ss);
	}
	
	public void testGenBootStrap() throws JDOMException, IOException {
		File f = new File("D:\\eclipse-workspace\\confluence-1.4\\src\\bootstrapContext.xml");
		String ss = ConvertUtil.xml2JacnClass(f);
		System.out.println(ss);
	}
	public void testGenDBSub() throws JDOMException, IOException {
		File f = new File("D:\\eclipse-workspace\\confluence-1.4\\src\\databaseSubsystemContext.xml");
		String ss = ConvertUtil.xml2JacnClass(f);
		System.out.println(ss);
	}
	public void testGenEventSub() throws JDOMException, IOException {
		File f = new File("D:\\eclipse-workspace\\confluence-1.4\\src\\eventSubsystemContext.xml");
		String ss = ConvertUtil.xml2JacnClass(f);
		System.out.println(ss);
	}
	public void testGenImpExpSub() throws JDOMException, IOException {
		File f = new File("D:\\eclipse-workspace\\confluence-1.4\\src\\importExportSubsystemContext.xml");
		String ss = ConvertUtil.xml2JacnClass(f);
		System.out.println(ss);
	}
	public void testGenIndexSub() throws JDOMException, IOException {
		File f = new File("D:\\eclipse-workspace\\confluence-1.4\\src\\indexingSubsystemContext.xml");
		String ss = ConvertUtil.xml2JacnClass(f);
		System.out.println(ss);
	}
	public void testGenPluginSub() throws JDOMException, IOException {
		File f = new File("D:\\eclipse-workspace\\confluence-1.4\\src\\pluginSubsystemContext.xml");
		String ss = ConvertUtil.xml2JacnClass(f);
		System.out.println(ss);
	}
	public void testGenRpcSub() throws JDOMException, IOException {
		File f = new File("D:\\eclipse-workspace\\confluence-1.4\\src\\rpcSubsystemContext.xml");
		String ss = ConvertUtil.xml2JacnClass(f);
		System.out.println(ss);
	}
	public void testGenScheduleSub() throws JDOMException, IOException {
		File f = new File("D:\\eclipse-workspace\\confluence-1.4\\src\\schedulingSubsystemContext.xml");
		String ss = ConvertUtil.xml2JacnClass(f);
		System.out.println(ss);
	}
	public void testGenUpgradeSub() throws JDOMException, IOException {
		File f = new File("D:\\eclipse-workspace\\confluence-1.4\\src\\upgradeSubsystemContext.xml");
		String ss = ConvertUtil.xml2JacnClass(f);
		System.out.println(ss);
	}
	public void testGenWikiFiltersSub() throws JDOMException, IOException {
		File f = new File("D:\\eclipse-workspace\\confluence-1.4\\src\\wikiFiltersSubsystemContext.xml");
		String ss = ConvertUtil.xml2JacnClass(f);
		System.out.println(ss);
	}
	public void testGenWikiSub() throws JDOMException, IOException {
		File f = new File("D:\\eclipse-workspace\\confluence-1.4\\src\\wikiSubsystemContext.xml");
		String ss = ConvertUtil.xml2JacnClass(f);
		System.out.println(ss);
	}
}
