package bran.spring.jacn;

import org.jdom.Element;

/**
 * inline array object
 * @author bran
 *
 */
class ArrayObject extends XmlElementObject {
	int arrayLength;
	ArrayObject(Object cst, int dimension) {
		super(cst);
		e = new Element("list");
		arrayLength = dimension;
	}
	
	public int getArrayLength() {
		return arrayLength;
	}

	void addValue(XmlElementObject value) {
		arrayLength++;
		if (value.isField() /*|| value.isLocalVar*/) {
			e.addContent(JacnMethodVisitor.newRefBean(value.name));
		}
		else {
			e.addContent(value.e);
		}
	}
}