package bran.spring.jacn;

import java.util.Stack;

/**
 * for easier setting breakpoint when debugging
 * 
 * @author bran
 *
 */
class MyStack extends Stack {
	   /** use serialVersionUID from JDK 1.0.2 for interoperability */
    private static final long serialVersionUID = 1224463164541339165L;
    
	public synchronized Object pop() {
		return super.pop();
	}

	public Object push(Object item) {
		return super.push(item);
	}
}