package bran.spring.jacn;

import org.jdom.Attribute;
import org.jdom.Element;
import org.springframework.transaction.interceptor.TransactionInterceptor;


public class TxInterceptor extends FieldElementObj {

	TxInterceptor(String targetName) {
		super(TransactionInterceptor.class.getName(), targetName + "__tx_interceptor", true);
		
	}

	void addTxManager(XmlElementObject txManObj) {
		Element te = new Element("property");
		te.getAttributes().add(new Attribute("name", "transactionManager"));
		if (txManObj.isField()) {
			Element refe = new Element("ref");
			refe.getAttributes().add(new Attribute("bean", txManObj.name));
			te.addContent(refe);
		}
		else /*if (txManObj.isLocalVariable())*/ {
			te.addContent((Element) txManObj.e.clone());
		}
		e.addContent(te);
	}

	void addTxAttributes(PropertiesObject props) {
		Element te = new Element("property");
		te.getAttributes().add(new Attribute("name", "transactionAttributes"));
		te.addContent( (Element)props.e.clone());
		e.addContent(te);
	}

}
