package bran.spring.jacn.faces;

import java.util.Iterator;
import java.util.Stack;

public class FlowStack extends Stack {
	public static final String FLOW_SEPARATOR = "/";

	public synchronized String getFlowPath() {
//		Iterator it = this.iterator();
		String res = "";
		for (Iterator iter = this.iterator(); iter.hasNext();) {
			Flow f = (Flow) iter.next();
			res += FLOW_SEPARATOR + f.getFlowid();
		}
		return "".equals(res) ? null : res;
	}

	public synchronized Object pushFlow(Flow item) {
		return super.push(item);
	}
	
	public synchronized Flow popFlow() {
		return (Flow)super.pop();
	}
	
	public synchronized Flow peekFlow() {
		return (Flow)peek();
	}
	
}
