package bran.jacn.test;

import java.util.ArrayList;
import java.util.List;
import java.util.Properties;

import org.springframework.beans.factory.config.ListFactoryBean;
import org.springframework.beans.factory.config.PropertyPlaceholderConfigurer;
import org.springframework.core.io.Resource;

import bran.spring.jacn.AbstractJacnConfigFile;

/**
 * @author bran bran@ccniit.com
 */
public class ApplicationContext_AB extends AbstractJacnConfigFile {
	public static final String _A = "a";
	static AA a;
	static BB b;
	static BBFactory bbf;

	static PropertyPlaceholderConfigurer ppc;
	
	public void wire() throws Exception {
//		
		String con = "${a.content2}";
		a.setContent(con);
		a.setNum(2);
		a.setB0(b);
		a.setB1(bbf.newInstance("hello", "b1"));
		a.setB2(BBFactory.newInstanceStatic("hello", "b2"));
		a.setB4(new BB("hello", "b4"));

		b = new BB("hello", "b");
		
		List list = new ArrayList();
		list.add("list value 1");
		list.add(ppc); // just for demoing purpose
		
		ListFactoryBean lfb = new ListFactoryBean();
		lfb.setSourceList(list);
		//lfb.setTargetListClass(ArrayList.class);  // .class not supported!
		b.setListProps((List) lfb.getObject());   // the pattern of factoryBean usage

		String[] mappings = new String[]{
                "com/lcare/model/Role.hbm.xml",
                "com/lcare/model/User.hbm.xml",};
		a.setNames(mappings);

		Properties p = new Properties();
		p.put("a.content", "${a.content}");
		a.setProps(p);
		
		String pa = "classpath:bran/jacn/test/p2.properties"; 
		Object[] locs = {"classpath:bran/jacn/test/p1.properties",pa,};
		
		ppc.setLocations((Resource[])locs);
		
	}
}
