package bran.jacn.test;

import java.util.HashMap;
import java.util.Map;

import bran.spring.jacn.AbstractJacnConfigFile;

public class TestCtorInject extends JacnTestCase {

	protected Class[] getConfigClasses() {
		return new Class[] {
				Jacn_CtorInject.class
		};
	}

	public void testCtorDI() throws Exception {
		AA a= (AA) getCtx().getBean("a");
		assertEquals(a.getB0().p1, "hello");
		
		CC c = (CC) getCtx().getBean("c");
		
		assertEquals("you", c.getMap().get("hello"));
	}
	
	static class CC {
		Map map;

		public CC(Map m) {
			map = m;
		}
		public Map getMap() {
			return map;
		}

		public void setMap(Map map) {
			this.map = map;
		}
	}
	static class Jacn_CtorInject extends AbstractJacnConfigFile {
		static AA a;
		static BB b;
		
		CC c;
		public void wire() throws Exception {
			
			String h = "hello";
			b = new BB(h, "b");
			a = new AA(b);
			
			Map m = new HashMap(); {
				m.put("hello", "you");
			}
			
			c = new CC(m);
		}
	}
}
