/*
 * $Log$
 * Revision 1.1  2005/08/03 21:02:30  branaway
 * so far it worked nicely with asm2.0. Hibernate -> cglib seems using 1.5.3. I'm going to see if I can make jacn asm1.5.3 compatible
 *
 * Revision 1.1  2005/08/03 12:42:50  branaway
 * added support for web application context integration: JacnWebApplicationContext
 *
 */
package bran.jacn.test;

import junit.framework.TestCase;

import org.springframework.mock.web.MockServletContext;
import org.springframework.web.context.ConfigurableWebApplicationContext;

import bran.spring.jacn.JacnWebApplicationContext;

public class TestRefBean extends TestCase {
	
	protected void setUp() throws Exception {
	}
	
	/**
	 * note the app context is loaded from an XML file and a Jacn file. 
	 *
	 */
	public void testJacnRefXmlBean() {
		ConfigurableWebApplicationContext wac;
		wac = new JacnWebApplicationContext();
		wac.setServletContext(new MockServletContext(""));
		wac.setConfigLocations(new String[] {
				"/bran/jacn/test/ApplicationContext-Bar.xml",
				"classpath:" + Jacn_fooRefBean.class.getName() + ".class"
				});
		wac.refresh();
		Foo f = (Foo) wac.getBean("foo");
		assertEquals(f.getBar().getMessage(), "hello bar!");
	}
}
