package bran.jacn.test;

public class TestSingletons extends JacnTestCase {

	protected Class[] getConfigClasses() {
		return new Class[] {
				ApplicationContext_foo.class,
				ApplicationContext_bar.class
		};
	}

	public void testSingletone() throws Exception {
		Foo foo = (Foo) getCtx().getBean("foo");
		Foo foo2 = (Foo) getCtx().getBean("foo");
		assertSame(foo, foo2);
		// foo1 is prototype
		Foo foo11 = (Foo) getCtx().getBean("foo1");
		Foo foo12 = (Foo) getCtx().getBean("foo1");
		assertNotSame(foo11, foo12);
	}

}
