package bran.jacn.testinternal;

import bran.spring.jacn.FieldElementObj;
import bran.spring.jacn.JacnClassVisitor;
import bran.spring.jacn.WebScope;
import junit.framework.TestCase;

public class TestJacnClassVisitor extends TestCase {
	public void testScopeSynch() {
		JacnClassVisitor cv = new JacnClassVisitor();
		cv.getBeanScopeMap().put("um", WebScope.SESSION_SCOPE);
		FieldElementObj f = new FieldElementObj(String.class.getName(), "um__target");
		cv.synchScope(f);
		assertEquals(WebScope.SESSION_SCOPE, cv.getBeanScopeMap().get("um__target"));
		
	}
}
